;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Thunder version 2.0, by Mattrizzle, original version by Ghettoyouth
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"              
                    dcb "MAIN"                                    
                    PHB                     
                    PHK                     
                    PLB                     
                    JSR SPRITE_CODE_START   
                    PLB                     
                    RTL      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_04F6F8:        dcb $20,$58,$43,$CF,$18,$34,$A2,$5E
DATA_04F700:        dcb $07,$05,$06,$07,$04,$06,$07,$05
ADDR_04F708:        dcb $A9

SPRITE_CODE_START:  PHX                       
                    LDX.W $0681               
                    LDA.B #$10                
                    STA.W $0682,X             
                    STZ.W $0683,X             
                    STZ.W $0684,X             
                    STZ.W $0685,X             
                    TXY                       
                    LDX.W $1FFB               
                    BNE ADDR_03E01B           
                    LDA.W $190D               
                    BEQ ADDR_03DFF0           
                    REP #$20                  ; Accum (16 bit) 
                    LDA.W $0701               
                    BRA ADDR_03E031           
ADDR_03DFF0:        LDA $14                   ; Accum (8 bit) 
                    LSR                       
                    BCC ADDR_03E036           
                    DEC $1FFC               
                    BNE ADDR_03E036           
                    TAX                       
                    LDA ADDR_04F708,X       
                    AND #$07                
                    TAX                       
                    LDA DATA_04F6F8,X       
                    STA $1FFC               
                    LDA DATA_04F700,X       
                    STA $1FFB               
                    TAX                       
                    LDA #$08                
                    STA $1FFD               
                    LDA #$18                
                    STA $1DFC               ; / Play sound effect 
ADDR_03E01B:        DEC $1FFD               
                    BPL ADDR_03E028           
                    DEC $1FFB               
                    LDA #$04                
                    STA $1FFD               
ADDR_03E028:        TXA                       
                    ASL                       
                    TAX                       
                    REP #$20                  ; Accum (16 bit) 
                    LDA.L $00B5DE,X       
ADDR_03E031:        STA $0684,Y 
                    SEP #$20                  ; Accum (8 bit) 
ADDR_03E036:        LDX $1429               
                    LDA #$00       
                    TAX                       
                    LDA #$0E                
                    STA $00                   
ADDR_03E042:        LDA $0705,X
                    STA $0686,Y             
                    INX                       
                    INY                       
                    DEC $00                   
                    BNE ADDR_03E042           
                    TYX                       
                    STZ $0686,X             
                    INX                       
                    INX                       
                    INX                       
                    INX                       
                    STX $0681
                    PLX                                      
                    RTS                       ; Return 